package com.jojubanking.boot.module.system.service.usersxq;

import org.springframework.stereotype.Service;
import javax.annotation.Resource;
import org.springframework.validation.annotation.Validated;

import java.util.*;
import com.jojubanking.boot.module.system.controller.admin.usersxq.vo.*;
import com.jojubanking.boot.module.system.dal.dataobject.usersxq.UsersXqDO;
import com.jojubanking.boot.framework.common.pojo.PageResult;

import com.jojubanking.boot.module.system.convert.usersxq.UsersXqConvert;
import com.jojubanking.boot.module.system.dal.mysql.usersxq.UsersXqMapper;

import static com.jojubanking.boot.framework.common.exception.util.ServiceExceptionUtil.exception;
import static com.jojubanking.boot.module.system.enums.ErrorCodeConstants.*;

/**
 * 用户信息 Service 实现类
 *
 * @author admin
 */
@Service
@Validated
public class UsersXqServiceImpl implements UsersXqService {

    @Resource
    private UsersXqMapper usersXqMapper;

    @Override
    public Long createUsersXq(UsersXqCreateReqVO createReqVO) {
        // 插入
        UsersXqDO usersXq = UsersXqConvert.INSTANCE.convert(createReqVO);
        usersXqMapper.insert(usersXq);
        // 返回
        return usersXq.getId();
    }

    @Override
    public void updateUsersXq(UsersXqUpdateReqVO updateReqVO) {
        // 校验存在
        this.validateUsersXqExists(updateReqVO.getId());
        // 更新
        UsersXqDO updateObj = UsersXqConvert.INSTANCE.convert(updateReqVO);
        usersXqMapper.updateById(updateObj);
    }

    @Override
    public void deleteUsersXq(Long id) {
        // 校验存在
        this.validateUsersXqExists(id);
        // 删除
        usersXqMapper.deleteById(id);
    }

    private void validateUsersXqExists(Long id) {
        if (usersXqMapper.selectById(id) == null) {
            throw exception(USERS_XQ_NOT_EXISTS);
        }
    }

    @Override
    public UsersXqDO getUsersXq(Long id) {
        return usersXqMapper.selectById(id);
    }

    @Override
    public List<UsersXqDO> getUsersXqList(Collection<Long> ids) {
        return usersXqMapper.selectBatchIds(ids);
    }

    @Override
    public PageResult<UsersXqDO> getUsersXqPage(UsersXqPageReqVO pageReqVO) {
        return usersXqMapper.selectPage(pageReqVO);
    }

    @Override
    public List<UsersXqDO> getUsersXqList(UsersXqExportReqVO exportReqVO) {
        return usersXqMapper.selectList(exportReqVO);
    }

}
